<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class SensorDeFluxoFactory {
    
    use TQuery;
    
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getSensores(){
        $sql="SELECT NRPARAMLEITCONTPESSOAS, IDMACDEVICE, IDSENSOR
                FROM FCM_PARAMLEITCONTPESSOAS";
                
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
    
    public function insertDadosSensores($dados){
        $sql="INSERT INTO FCM_LEITCONTPESSOAS (NRSEQLEITURA, IDMACDEVICE, IDSENSOR, QTPESSOASENTR, IPSENSOR,
                        NRORG, IDATIVO, OBS, DTLEITURA)
                     VALUES (:NRSEQLEITURA, :IDMACDEVICE, :IDSENSOR, :QTPESSOASENTR, :IPSENSOR,
                     :NRORG, :IDATIVO, :OBS, SYSDATE)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($dados);
        // TO_DATE(SYSDATE, 'DD/MM/YYYY HH24:MI')
        // return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $dados);
    }
}

?>