import Vue from 'vue';
import Vuex from 'vuex';

Vue.use(Vuex);

export default new Vuex.Store({
  state: {
    routerParams: {},
    menu: JSON.parse(<string>localStorage.getItem('MENU')) || [],
  },
  mutations: {
    setRouterParams: (state, value: any) => {
      state.routerParams = value;
      localStorage.setItem('routeParams', JSON.stringify(value));
    },
    setMenu: (state, value: any) => {
      state.menu = value;
    },
  },
  actions: {
  },
  getters: {
    routerParams: (state) => state.routerParams,
    getMenu: (state) => state.menu,
  },
});
